/*
 * data.cpp
 *
 *  Created on: Mar 11, 2015
 *      Author: abhattac
 */

#include "Data.h"

#include "../misc/Pattern.h"

#include <string>
#include <iostream>
#include <fstream>

using namespace std;


Data::Data(string filename, uint32_t max_size) {
	this->max_size = max_size;
	// TODO Auto-generated constructor stub
	//u = new <char> UnBoundedArray;
	uint32_t max_pattern_num = 0;
	ifstream file_stream(filename);     // open file

	char c;
	this->alpha_count.push_back( 0 );
	this->data_stream.push_back( 0 );
	int new_pattern = 0, pos_power = 1, pattern_len = 0;
	vector<int> tstore;
	bool ignore_as_missing = false;
	uint32_t count = 0;
	while( file_stream.get(c) && count < this->max_size )          // loop getting single characters
	{
		if( !ignore_as_missing )
		{
			if( c == '-' )
			{
				ignore_as_missing = true;
			}
			else if( c == ' ')
			{
				continue;
			}
			else if( c != ',' )
			{
				tstore.push_back( (int)(c - 48) );
				pattern_len++;
			}
			else
			{
				pattern_len --;
				pos_power = 1;
				new_pattern = 0;
				while (pattern_len >= 0)
				{
					new_pattern += pos_power * tstore[pattern_len];
					pos_power *= 10;
					pattern_len --;
				}
				pattern_len++;
				data_stream.push_back(new_pattern);

				if( new_pattern > max_pattern_num )
				{
					for(int i = max_pattern_num + 1; i <= new_pattern; i++)
					{
						alpha_count.push_back(0);
					}
					max_pattern_num = new_pattern;
					this->max_alpha_num = max_pattern_num;
				}
				if( alpha_count[ new_pattern ] == 0 )
				{
					alphabets.push_back(new_pattern);
					vector<uint32_t> *inv_idx = new vector<uint32_t>;
					inverted_index[ new_pattern ] = inv_idx;
				}

				inverted_index[ new_pattern ]->push_back( data_stream.size() - 1 );
				alpha_count[new_pattern]++;

				tstore.clear();
				new_pattern = 0;
				pos_power = 1;
				count++;

			}
		}
		else
		{
			if( c == ',' )
			{
				data_stream.push_back( -1 );
				this->num_of_seq++;
				ignore_as_missing = false;
				tstore.clear();
				new_pattern = 0;
				pos_power = 1;
			}
		}
	}
	cout << "data stream size: " << data_stream.size() << endl;
	file_stream.close();
}

Data::~Data() {
}

int32_t Data::charAt(uint32_t i) const
{
	return data_stream[i];
}

uint32_t Data::getAlphabetSupport(uint32_t tmp) const
{
	return alpha_count[tmp];
}

void Data::setAlphabetSupport(uint32_t x, uint32_t supp)
{
	alpha_count[x] = supp;
}

uint32_t Data::getSize() const
{
	return data_stream.size();
}

uint32_t Data::getNumOfAlphabets() const
{
	return alphabets.size();
}

uint32_t Data::getMaxAlphaNum() const
{
	return this->max_alpha_num;
}

uint32_t Data::getLoactionOfAlphabet( uint32_t alpha,  uint32_t occ )
{
	return this->inverted_index[ alpha ]->at( occ );
}

uint32_t Data::getNumOfSeq() {
	return this->num_of_seq;
}

