/*
 * data.h
 *
 *  Created on: Mar 11, 2015
 *      Author: abhattac
 */

#ifndef SQS_DATA_H_
#define SQS_DATA_H_
#include <string>
#include <iostream>
#include <fstream>
#include <vector>
#include <cstdint>
#include <climits>
#include <unordered_map>

using namespace std;

class Data {
private:
	vector<uint32_t> alpha_count;
	vector<uint32_t> alphabets;
	vector<int32_t> data_stream;
	 unordered_map< uint32_t, vector<uint32_t>*> inverted_index;
	int max_alpha_num = 0;
	uint32_t max_size = INT_MAX;
	uint32_t num_of_seq = 1;

public:
	Data(string filename, uint32_t max_size);
	~Data();
	int32_t charAt(uint32_t i) const;
	uint32_t getAlphabetSupport(uint32_t c) const;
	void setAlphabetSupport(uint32_t x, uint32_t supp);
	uint32_t getSize() const;
	uint32_t getNumOfAlphabets() const;
	uint32_t getMaxAlphaNum() const;
	uint32_t getLoactionOfAlphabet( uint32_t alpha, uint32_t occ );
	uint32_t getNumOfSeq();
};

#endif /* SQS_DATA_H_ */
