/*
 * dataCover.cpp
 *
 *  Created on: Mar 17, 2015
 *      Author: abhattac
 */

#include "DataCover.h"

#include <iostream>
#include <string.h>
#include "Mwindow.h"

using namespace std;

DataCover::DataCover(int size) {
	// TODO Auto-generated constructor stub

	for(int i = 0; i < size; i++)
	{
		windows.push_back( -1 );
	}
	this->size = size;
	this->total_covered_positions = 0;
}

void DataCover::cover_with_window(Mwindow *mw)
{
	for(int k=0; k<mw->pattern->getSize(); k++)
	{
		windows[ mw->getPositionInData(k) ] = mw->pattern->getPatternNum();
		total_covered_positions++;
	}
}

void DataCover::uncover_window( Mwindow *mw )
{
	for(int k=0; k<mw->pattern->getSize(); k++)
	{
		windows[ mw->getPositionInData(k) ] = -1;
		total_covered_positions--;
	}
}

bool DataCover::is_covered(int idx) {
	if( windows[idx] >= 0 )
		return true;
	return false;
}

int DataCover::next_uncovered_index(int idx) {

	while( (idx+1) < size )
	{
		idx++;
		if( windows[idx] == -1 )
		{
			return idx;
		}
	}
	return -1;
}

bool DataCover::is_fully_covered() {
	if( total_covered_positions == size )
	{
		return true;
	}
	return false;
}

int DataCover::get_size_of_curr_win(int idx) {
	int i = idx, j = idx;
	while( windows[idx] == windows[i]  )
	{
		i--;
	}
	i++;
	while( windows[idx] == windows[j]  )
	{
		j++;
	}
	j--;
	return j - i + 1;
}

int DataCover::windowAt(int idx)
{
	return windows[idx];
}

DataCover::~DataCover() {
	// TODO Auto-generated destructor stub
	windows.clear();
}

int DataCover::getSize()
{
	return this->size;
}

