/*
 * dataCover.h
 *
 *  Created on: Mar 17, 2015
 *      Author: abhattac
 */

#include "../misc/Pattern.h"
#include <vector>
#include "../misc/Mwindow.h"
#include <cstdint>

#ifndef DATACOVER_H_
#define DATACOVER_H_

class DataCover {
private:
	std::vector<int32_t> windows;
	int size;
	int total_covered_positions;

public:
	DataCover(int size);
	virtual ~DataCover();

	void cover_with_window(Mwindow *mw);
	void uncover_window(Mwindow *mw);
	int next_uncovered_index(int idx);
	bool is_covered(int idx);
	bool is_fully_covered();
	int windowAt(int idx);
	int get_size_of_curr_win(int idx);
	int getSize();
};

#endif /* DATACOVER_H_ */
