/*
 * EncodingCalucator.cpp
 *
 *  Created on: Mar 11, 2015
 *      Author: abhattac
 */
#include <math.h>
#include <cstdint>
#include "../misc/EncodingCalucator.h"

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif



EncodingCalucator::EncodingCalucator() {
	// TODO Auto-generated constructor stub

}

double EncodingCalucator::ln(double x) {
	double tmp = 0;
	while( x > 0 )
	{
		x = log2(x);
		tmp += x;
	}
	return tmp + log2(2.865064);
}

double EncodingCalucator::lu(double x) {
	if( x == 0 )
	{
		return 0;
	}
	return log2(x);
}

int EncodingCalucator::choose(int n, int k) {
	if (k > n) return 0;
	if (k * 2 > n) k = n-k;
	if (k == 0) return 1;

	int result = n;
	for( int i = 2; i <= k; ++i ) {
		result *= (n-i+1);
		result /= i;
	}
	return result;
}

double EncodingCalucator::approxlogchoose(double n, double m) {

	if( n == 0 || m == 0 || n <= m)
	{
		return 0;
	}
	return ((double) (n + 0.5) * log(n) - (m + 0.5) * log(m) - (n - m + 0.5)*log(n - m) - 0.5 * log(2 * M_PI) )/(log(2));

}

double EncodingCalucator::ln_factorial( int a)
{
	if (a == 1)
	{
		return 0;
	}
	else
	{
		double z = 0;

		for (int y = 2; y <= a; y++ )
		{
			z = log(y)+z;
		}
		return z;
	}
}

int EncodingCalucator::ln_double_factorial_exact( int n )
{
	int fact=1;
	int i=0;

	if(n%2 == 0){
		i=2;
	}else {
		i=1;
	}
	for(int j=i; j<=n; j+=2) {
		 fact = fact*j;
	}
	return log2(fact);
}

double EncodingCalucator::log_double_factorial(double two_n_minus_one)
{
	if ( two_n_minus_one <= 1)
	{
		return 0.0;
	}

	double two_n = two_n_minus_one + 1;
	double n = two_n / 2;
	return ln_factorial( two_n ) - n - ln_factorial( n );
}


double EncodingCalucator::log_gamma( double z )
{
    // Nemes approximation
    if (z <= 0) return 0;
    if (z == 0.5) return log2(sqrt(M_PI));
    return 0.5 * (log2(2 * M_PI) - log2(z)) + z * (log2(z + 1 / (12 * z - 1 / (10 * z))) - 1);
}

double EncodingCalucator::logWeakNumberComposition(int n, int k) {
	return approxlogchoose(n + k - 1, k - 1);
}

EncodingCalucator::~EncodingCalucator() {
	// TODO Auto-generated destructor stub
}

