/*
 * create_parallel_data.cpp
 *
 *  Created on: Jun 17, 2016
 *      Author: abhattac
 */

#include <vector>
#include "Pattern.h"
#include <cstdint>
#include <iostream>
#include <fstream>

using namespace std;

typedef int32_t int32;
typedef uint32_t uint32;

class PatCont {
private:
	Pattern *p;
	int32 idx = 0;
public:
	PatCont( Pattern *p )
	{
			this->p = p;
	}

	int32 getNextChar( )
	{
		return p->charAt( idx++ % p->getSize() );
	}

	void reset()
	{
		this->idx = 0;
	}

};

void create_dummy_parallel_patterns( vector<Pattern*> &p_list )
{
	for( int start = 0; start < 10; start++ )
	{
		int tmp_pat[5] = { 5*start, 5*start + 1, 5*start + 2, 5*start + 3, 5*start + 4 };
		vector<int> tmp_pat_vec ( tmp_pat, tmp_pat + sizeof(tmp_pat) / sizeof(int) );
		Pattern *tp = new Pattern( tmp_pat_vec );
		p_list.push_back( tp );
		//tp->printPattern();
	}
}

void create_pat_conts( vector<Pattern*> list_of_patterns, vector<PatCont> &list_of_pat_cont )
{
	for( uint32 i = 0; i < list_of_patterns.size(); i++  )
	{
		PatCont tpc( list_of_patterns[i] );
		list_of_pat_cont.push_back( tpc );
	}
}

void reset_conts( vector<PatCont> &list_of_pat_cont )
{
	for(uint32 i = 0; i < list_of_pat_cont.size(); i++ )
	{
		list_of_pat_cont[i].reset();
	}
}

void write_parallel_data( vector<int> &data_stream, char *filename )
{
	ofstream data_stream_to_file;
	data_stream_to_file.open( filename );
	for(uint32  i = 0; i < data_stream.size(); i++ )
	{
		//cout << data_stream[i] << "," << endl;
		data_stream_to_file << data_stream[i] << ",";
	}
	data_stream_to_file.close();
}

void create_parallel_data( char *filename )
{
	vector<int32> data_stream;

	vector<Pattern*> list_of_patterns;
	create_dummy_parallel_patterns( list_of_patterns );

	vector<PatCont> list_of_pat_cont;

	create_pat_conts( list_of_patterns, list_of_pat_cont );

	for(uint32 seq = 0; seq < 10000; seq++ )
	{
		for(uint32 data_idx = 0; data_idx < 100; data_idx++ )
		{
			data_stream.push_back( list_of_pat_cont[ rand() % 5 ].getNextChar() );
		}
		//reset_conts( list_of_pat_cont );
		//data_stream.push_back( -1 );
	}

	write_parallel_data( data_stream, filename );
}


