/*
 * find_win_pq.cpp
 *
 *  Created on: Jun 29, 2016
 *      Author: abhattac
 */




#include <vector>
#include "../misc/Data.h"
#include "../misc/Pattern.h"
#include "../misc/Mwindow.h"
#include "../misc/common_functions.h"
#include <algorithm>
#include <cstdint>
#include <queue>

typedef uint32_t uint32;
typedef int32_t int32;

struct mw_cont
{
	uint32 start_idx = 0;
	uint32 curr_idx = 0;
	uint32 gaps = 0;
	uint32 pattern_comp_idx = 1;
	vector<uint32> pos;
	bool operator<(const mw_cont& rhs) const
	{
		return gaps > rhs.gaps;
	}
};

bool comp_Mwindows(Mwindow* a, Mwindow* b)
{
    return a->getStartIndex() < b->getStartIndex();
}

void init_pq( Data *D, Pattern* P, priority_queue<mw_cont> &pq )
{

	for( uint32 i = 0; i < D->getAlphabetSupport( P->charAt(0) ); i++ )
	{
		mw_cont tmwc;
		tmwc.start_idx = D->getLoactionOfAlphabet( P->charAt(0), i );
		tmwc.curr_idx = tmwc.start_idx + 1;
		tmwc.pos.push_back( tmwc.start_idx );
		pq.push( tmwc );
	}
	/*for(uint32 i = 0; i < D->getSize() - P->getSize(); i++ )
	{
		if( D->charAt(i) != -1 && D->charAt(i + 1) != -1 && D->charAt(i) == P->charAt(0) )
		{
			mw_cont tmwc;
			tmwc.start_idx = i;
			tmwc.curr_idx = i + 1;
			tmwc.pos.push_back( i );
			pq.push( tmwc );
		}
	}*/
}


void find_win_pq( Data *D, Pattern* P, vector<Mwindow*> &found_win )
{
	priority_queue<mw_cont> pq;
	vector<mw_cont> choosen_cont;
	int32 budget =  0;
	//P->printPattern();
	init_pq( D, P, pq );
	while( !pq.empty() )
	{
		//cout << "Budget: " << budget << endl;
		mw_cont current_best_cont = pq.top();
		pq.pop();
		if( D->charAt( current_best_cont.curr_idx ) == -1 )
		{
			continue;
		}
		if( D->charAt( current_best_cont.curr_idx ) == P->charAt( current_best_cont.pattern_comp_idx ) )
		{
			current_best_cont.pos.push_back( current_best_cont.curr_idx );
			current_best_cont.curr_idx++;
			current_best_cont.pattern_comp_idx++;

			if( current_best_cont.pattern_comp_idx == P->getSize() )
			{
				choosen_cont.push_back( current_best_cont );
				int32 eb = max( ((int32)P->getSize() - (int32)current_best_cont.gaps) - 2, 0 );
				//cout << "eb: " << eb <<  endl;
				budget += eb;
			}
			else
			{
				pq.push( current_best_cont );
			}
		}
		else
		{
			current_best_cont.gaps++;
			current_best_cont.curr_idx++;
			if( (int32)P->getSize() + 0 + budget - (int32)current_best_cont.gaps >= 0 )
			{
				pq.push( current_best_cont );
			}
			else if( current_best_cont.pattern_comp_idx > 2 )
			{
				/*choosen_cont.push_back( current_best_cont );
				int32 eb = max( ((int32)P->getSize() - (int32)current_best_cont.gaps) - 2, 0 );
				//cout << "eb: " << eb <<  endl;
				budget += eb;*/
			}
		}
	}

	for(uint32 i = 0; i < choosen_cont.size(); i++ )
	{
		uint32 ii = choosen_cont[i].start_idx;
		uint32 j = choosen_cont[i].pos[ choosen_cont[i].pos.size() - 1 ];
		uint32 gaps = 0;
		if( choosen_cont[i].pattern_comp_idx == P->getSize() )
		{
			gaps = choosen_cont[i].gaps;
		}
		else
		{
			gaps = (int32)j - (int32)ii - (int32)choosen_cont[i].pattern_comp_idx + 1;
		}
		Mwindow* tmw = new Mwindow( ii, j, P, 0, choosen_cont[i].pos, gaps, choosen_cont[i].pattern_comp_idx);
		found_win.push_back( tmw );
	}
	sort( found_win.begin(), found_win.end(), comp_Mwindows );
	//cout << "Win found: " << found_win.size() << endl;
	//exit(0);
}
